/**
 * @name		Maximenu CK Hikashop
 * @package		com_maximenuckhikashop
 * @copyright	Copyright (C) 2016. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */

var $ck = jQuery.noConflict();

$ck(document).ready(function(){
	ckInitMenusManagerck();
	$ck('#adminForm').append('<div id="ckoverlay"></div>');
	ckInitTogglers();
	// $ck( ".cktip" ).tooltip({ tooltipClass: "cktooltip", position: { my: "left+15 center", at: "right center" }, "container": "body" });
});

function ckInitTogglers() {
	$ck('.itemtoggler').not('.togglerdone').each(function() {
		$ck(this).click(function() {
			$ck($ck($ck(this).parents('li')[0]).find('.togglecontent')[0]).toggle('fast');
			$ck(this).toggleClass('opened');
		});
		$ck(this).addClass('togglerdone');
	});
}

function ckInitMenusManagerck() {
		$ck('.disclose').on('click', function() {
			$ck(this).closest('li').toggleClass('collapsed').toggleClass('expanded');
		});
}

function ckAddWaitIcon(button) {
	button.addClass('ckwait');
	button.find('i').css('visibility', 'hidden');
}

function ckAddWaitLayer() {
	$ck('#ckoverlay').show();
}

function ckRemoveWaitLayer() {
	$ck('#ckoverlay').hide();
}

function ckRemoveWaitIcon(button, failed) {
	if (failed) {
		button.find('i').attr('class','icon-warning');
	} else {
		button.removeClass('ckwait');
		button.find('i').css('visibility', 'visible');
	}
}

function ckSaveParam(id, param, value, btn, waiticon, callback, args ) {
	if (!waiticon) waiticon = false;
	if (waiticon) ckAddWaitIcon($ck(btn));
	var myurl = "index.php?option=com_maximenuckhikashop&task=item.saveParam";
	jQuery.ajax({
	type: "POST",
	url: myurl,
	data: {
		id: id,
		param: param,
		value:value
		}
	}).done(function(code) {
		if (code == '1') {
			if (waiticon) ckRemoveWaitIcon($ck(btn), false);
			if (callback && typeof window[callback] == 'function') { if (!args) args = null;window[callback](args); }
		} else {
			if (waiticon) ckRemoveWaitIcon($ck(btn), true);
			alert(Joomla.JText._('CK_PARAM_NOT_UPDATED', 'CK_PARAM_NOT_UPDATED')+code);
		}
	}).fail(function() {
		alert(Joomla.JText._('CK_PARAM_UPDATE_FAILED', 'CK_PARAM_UPDATE_FAILED'));
		if (waiticon) ckRemoveWaitIcon($ck(btn), true);
	});
}

function ckToggleColumn(btn) {
	$ck(btn).toggleClass('active').toggleClass('btn-primary');
	$ck(btn).parent().toggleClass('active');
	var item = $ck($ck(btn).parents('li')[0]);

	if (item.attr('data-level') == '1') {
		alert(Joomla.JText._('CK_NO_COLUMN_ON_ROOT_ITEM', 'WARNING : You can not create a column on a root item, this will kill your layout !'));
	}
	ckSaveParam(item.attr('data-id'), 'maximenu_createcolumn', $ck(btn).hasClass('active') ? '1' : '0', btn, true);
}

function ckChangeColwidth(btn) {
	var colwidth = prompt('Column width', $ck(btn).text());
	if (colwidth == null) return;
	var item = $ck($ck(btn).parents('li')[0]);

	ckSaveParam(item.attr('data-id'), 'maximenu_colwidth', colwidth, btn, true);
	$ck(btn).text(colwidth);
}

function ckCreateNewRow(btn) {
	$ck(btn).toggleClass('active').toggleClass('btn-primary');
	var item = $ck($ck(btn).parents('li')[0]);

	ckSaveParam(item.attr('data-id'), 'maximenu_createnewrow', $ck(btn).hasClass('active') ? '1' : '0', btn, true);
}

function ckToggleSubmenuwidth(btn) {
	if ( $ck($ck(btn).parents('li')[0]).find('.submenuwidth').find('.valuetxt').html().length
		|| $ck($ck(btn).parents('li')[0]).find('.submenuheight').find('.valuetxt').html().length
		|| $ck($ck(btn).parents('li')[0]).find('.submenuleftmargin').find('.valuetxt').html().length
		|| $ck($ck(btn).parents('li')[0]).find('.submenutopmargin').find('.valuetxt').html().length		) {
		alert(Joomla.JText._('CK_FIRST_CLEAR_VALUE', 'CK_FIRST_CLEAR_VALUE'));
		return;
	}

	$ck(btn).toggleClass('active');
	$ck(btn).parent().toggleClass('active');
}

function ckChangeSubmenuwidth(btn) {
	var submenuwidth = prompt('Submenu width', $ck(btn).find('.valuetxt').text());
	if (submenuwidth == null) return;
	var item = $ck($ck(btn).parents('li')[0]);

	ckSaveParam(item.attr('data-id'), 'maximenu_submenucontainerwidth', submenuwidth, btn, true);
	$ck(btn).find('.valuetxt').text(submenuwidth);
}

function ckChangeSubmenuheight(btn) {
	var submenuheight = prompt('Submenu height', $ck(btn).find('.valuetxt').text());
	if (submenuheight == null) return;
	var item = $ck($ck(btn).parents('li')[0]);

	ckSaveParam(item.attr('data-id'), 'maximenu_submenucontainerheight', submenuheight, btn, true);
	$ck(btn).find('.valuetxt').text(submenuheight);
}

function ckChangeFullwidthClass(btn) {
	$ck(btn).toggleClass('active').toggleClass('btn-primary');
	var item = $ck($ck(btn).parents('li')[0]);

	ckSaveParam(item.attr('data-id'), 'fullwidth', $ck(btn).hasClass('active') ? '1' : '0', btn, true);
}

function ckChangeNodropdownClass(btn) {
	$ck(btn).toggleClass('active').toggleClass('btn-primary');
	var item = $ck($ck(btn).parents('li')[0]);

	ckSaveParam(item.attr('data-id'), 'nodropdown', $ck(btn).hasClass('active') ? '1' : '0', btn, true);
}

function ckChangeSubmenuleftmargin(btn) {
	var submenuleftmargin = prompt('Submenu left margin', $ck(btn).find('.valuetxt').text());
	if (submenuleftmargin == null) return;
	var item = $ck($ck(btn).parents('li')[0]);

	ckSaveParam(item.attr('data-id'), 'maximenu_leftmargin', submenuleftmargin, btn, true);
	$ck(btn).find('.valuetxt').text(submenuleftmargin);
}

function ckChangeSubmenutopmargin(btn) {
	var submenutopmargin = prompt('Submenu top margin', $ck(btn).find('.valuetxt').text());
	if (submenutopmargin == null) return;
	var item = $ck($ck(btn).parents('li')[0]);

	ckSaveParam(item.attr('data-id'), 'maximenu_topmargin', submenutopmargin, btn, true);
	$ck(btn).find('.valuetxt').text(submenutopmargin);
}

function ckSaveDescription(btn) {
	var item = $ck($ck(btn).parents('li')[0]);
	var txt = btn.value;
	if (txt != $ck(btn).attr('text-origin')) {
		ckSaveParam(item.attr('data-id'), 'maximenu_desc', txt, btn, true, 'ckSetSuccessDescription', Array(btn, txt));
	}

}

function ckSetSuccessDescription(params) {
	$ck(params[0]).attr('text-origin', params[1]);
}

function ckToggleDesktopState(btn) {
	$ck(btn).toggleClass('disable');
	var item = $ck($ck(btn).parents('li')[0]);

	ckSaveParam(item.attr('data-id'), 'maximenu_disabledesktop', $ck(btn).hasClass('disable') ? '1' : '0', btn, true);
}

function ckToggleMobileState(btn) {
	console.log($ck(btn).hasClass('disable'));
	$ck(btn).toggleClass('disable');
	var item = $ck($ck(btn).parents('li')[0]);

	ckSaveParam(item.attr('data-id'), 'maximenu_disablemobile', $ck(btn).hasClass('disable') ? '1' : '0', btn, true);

}

function ckCallIconsPopup(id) {
	var BSmodal = jQuery('#maximenuckhikashopModalIcons');
	BSmodal.attr('data-fieldid', id);
	BSmodal.modal('show');
}
	
function ckSelectFaIcon(iclass) {
	jQuery('#maximenuckhikashopModalIconsFieldid').val(iclass).trigger('change');
}

function ckSetFaIcon(iclass, fieldid) {
	var btn = '#'+fieldid;
	var item = $ck($ck(btn).parents('li')[0]);

	ckSaveParam(item.attr('data-id'), 'maximenu_icon', iclass, btn, true, 'ckSuccessFaIcon', Array(fieldid, iclass));

	jQuery('#maximenuckhikashopModalIcons').modal('hide');
}

function ckSuccessFaIcon(params) {
	jQuery('#'+params[0]).addClass('active').find('i').attr('class', params[1]);
	jQuery('#'+params[0]).next('input').val(params[1]);
}

function ckRemoveFaIcon(btn) {
	if (!confirm(Joomla.JText._('CK_CONFIRM_DELETE','CK_CONFIRM_DELETE'))) return;

	var item = $ck($ck(btn).parents('li')[0]);
	
	ckSaveParam(item.attr('data-id'), 'maximenu_icon', '', $ck(btn).prev(), true);
	$ck(btn).prev().prev().removeClass('active').find('i').removeAttr('class');
	$ck(btn).prev().val('');
}

function ckCallImagePopup(id) {
	var BSmodal = jQuery('#maximenuckhikashopModalImagemanager');
	BSmodal.attr('data-fieldid', id);
	BSmodal.modal('show');
}

function ckSetImage(image_url, fieldid) {
	var btn = '#'+fieldid;
	var item = $ck($ck(btn).parents('li')[0]);
	var title = $ck(btn).attr('data-original-title');
	var tmp = $ck('<div />').append(title);
	var rep = tmp.find('img').attr('src');
	if (tmp.find('img').length) {
		$ck(btn).attr('data-original-title', $ck(btn).attr('data-original-title').replace(rep,URIROOT + '/' + image_url));
	} else {
		$ck(btn).attr('data-original-title', title + '<br /><img src="' + URIROOT + '/' + image_url + '" style="max-width:200px;max-height:200px;"/>');
	}
	ckSaveParam(item.attr('data-id'), 'menu_image', image_url, btn, true);
	$ck(btn).addClass('active');
	jQuery('#maximenuckhikashopModalIcons').modal('hide');
}

function ckRemoveImage(btn) {
	if (!confirm(Joomla.JText._('CK_CONFIRM_DELETE','CK_CONFIRM_DELETE'))) return;

	var item = $ck($ck(btn).parents('li')[0]);
	var title = $ck(btn).prev().attr('data-original-title');
	var pos = title.indexOf('<br />');
	
	ckSaveParam(item.attr('data-id'), 'menu_image', '', $ck(btn).prev(), true);
	$ck(btn).prev().attr('data-original-title', title.substring(0, pos)).removeClass('active');
}

